import {
  select,csv,scaleLinear,extent,axisLeft,axisBottom,
  format,scaleTime,line,curveBasis,timeFormat
} from 'd3';


import{ dropdownMenu } from './dropdownMenu';
import{scatterPlot} from './scatterPlot';


const svg = select('svg');

const height = +svg.attr('height');
const width = +svg.attr('width');

let Ldata;
let yColumn;



//get column from dropdown menu and render plot
const OnYColumnClicked = column => {
	yColumn = column;
  render();
};

//Create a form
 select('#InputForm')
  .append('form').attr('id','some');
  
  //add form element
 const Myform = select('#some');

//add input box(year)
Myform.append('input')
			.attr('type',"text")
			.attr('class','Inputfield')
			.attr('id','yearinput')
      .attr('placeholder','Year');
       
Myform.append('input')
			.attr('type',"text")
			.attr('class','Inputfield')
			.attr('id','sinput')
      .attr('placeholder','S');

Myform.append('input')
			.attr('type',"text")
			.attr('class','Inputfield')
			.attr('id','cinput')
      .attr('placeholder','C');

//Create submit button
 Myform.append('input')
      .attr('type','button')
		  .attr('id','myButton')
      .attr('value','Submit');

//Update Data
 select('#myButton')
					.on('click', function(){
   						const newyear =new Date(document.getElementById("yearinput").value);
             		
   						const newS = document.getElementById("sinput").value;
              
   						const newC = document.getElementById("cinput").value;
              
   						Ldata.push({year: newyear,S:newS, C: newC});
   
              console.log(Ldata);
   						document.getElementById("yearinput").value = null;
   						document.getElementById("sinput").value = null;
   						document.getElementById("cinput").value = null;
   
   						render();
          });
   

//data handelling
const render = () =>{  
  
  //Invoke menu component
  select('#menus')
  .call(dropdownMenu,  {
		options: Ldata.columns,
    onOptionClicked: OnYColumnClicked
	});
  
  //Invoke scatter plot component
  svg.call(scatterPlot,{
  	xValue: d => d.year,
  	xAxisLabel : 'Year',
   	yValue : d=>d[yColumn],
    yAxisLabel : 'Data',
   	margin : {top:20, right:35, bottom:56, left:70},
    width,
    height,
    data: Ldata
  });
  
};

//get data and pass to data handelling

//LEFT
csv('https://vizhub.com/norangai/datasets/eyeSight.csv')
  .then(loadedData=>{
 	  Ldata = loadedData;
  
		Ldata.forEach(d => {
  		console.log(d);
    d.year = new Date(d.year);
    d.S =  +d.S;
    d.C = +d.C;
    console.log(d);
  });
  yColumn = Ldata.columns[1];
 
  
  render();
  
});

